import { useCallback, useEffect, useRef, useState } from 'react';
import { useManagePostoAdmsContext } from '../hooks/useManagePostoAdmsContext';
import { Alert, useDataGrid } from '@/components';
import { useCallApi } from '@/hooks';
import { getAuth } from '@/auth';
import { apiConfig } from '@/config/api.config';
import { toast } from 'sonner';
import {
  Dialog,
  DialogBody,
  DialogContent,
  DialogDescription,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Input } from '@/components/ui/input';
import { Button } from '@/components/ui/button';
import { Popover, PopoverContent, PopoverTrigger } from '@/components/ui/popover';
import {
  Command,
  CommandEmpty,
  CommandGroup,
  CommandInput,
  CommandItem,
  CommandList
} from '@/components/ui/command';
import { doSaveLogActivity } from '@/actions/GlobalActions';

interface MunicipioProps {
  id: number;
  name: string;
}

const API_URL = apiConfig.service_master_data;

const EditDialog = () => {
  const parentRef = useRef<any | null>(null);
  const { showEditDialog, handleEditDialog, selectedPostoAdms, postoAdms } =
    useManagePostoAdmsContext();
  const { reload } = useDataGrid();
  const { PutData, GetData } = useCallApi();
  const parsedUser = getAuth()?.user;
  const [open, setOpen] = useState(false);
  const [municipios, setMunicipios] = useState<MunicipioProps[]>([]);

  const [alert, setAlert] = useState({
    show: false,
    message: ''
  });
  const initialState = {
    name: '',
    municipio_id: 0,
    updated_by: '',
    updated_at: ''
  };
  const [formField, setFormField] = useState(initialState);
  const created_time = new Date();
  const formattedTime = created_time.toISOString().slice(0, 19).replace('T', ' ');

  const resetForm = () => {
    setFormField(initialState);
    setAlert({ show: false, message: '' });
  };

  const doUpdatePostoAdm = useCallback(
    async (e: React.FormEvent<HTMLFormElement>) => {
      e.preventDefault();

      const response = await PutData(`${API_URL}/postoadms/update/${selectedPostoAdms}`, formField);

      if (response?.status) {
        handleEditDialog(false, null);
        resetForm();
        toast.success('Success Update Postu Administrativo');
        reload();

        const createActivity = {
          module: 'Manage Postu Administrativo',
          description: `Edit Postu Administrativo => ${selectedPostoAdms}`,
          action: 'U'
        };

        doSaveLogActivity(createActivity);
      } else {
        toast.error('Error Update Postu Administrativo');
        setAlert({
          show: true,
          message: 'Failed to update Postu Administrativo Please try again.'
        });
      }
    },
    [selectedPostoAdms, formField]
  );

  const doFetchMunicipios = useCallback(async (sorting: any) => {
    try {
      sorting = sorting.length == 0 ? [{ id: 'name', desc: false }] : sorting;
      const response = await GetData(`${API_URL}/municipios/list`, {
        limit: 100,
        page: 1,
        with_deleted: false,
        order_field: sorting[0].id,
        order_direction: sorting[0].desc == false ? 'ASC' : 'DESC'
      });

      // console.log('MUNICIPIOS: ', response?.data);
      setMunicipios(response?.data.list);
    } catch (error) {
      console.error('Error fetching Municipio', error);
      setAlert({ show: true, message: 'Failed to get Municipio. Please try again.' });
    }
  }, []);

  const doFetchData = useCallback(async (id: string) => {
    const response = await GetData(`${API_URL}/postoadms/getdata/${id}`, { id });

    if (response?.status) {
      setFormField((prev) => ({
        ...prev,
        name: response.data.name,
        municipio_id: response.data.municipios.id
      }));
    } else {
      setFormField((prev) => ({
        ...prev,
        name: ''
      }));
    }
  }, []);

  const handleUpdate = (e: React.FormEvent<HTMLFormElement>) => {
    e.preventDefault();

    if (formField.name.trim() === '' || formField.municipio_id === 0) {
      setAlert({ show: true, message: 'Please fill in all required fields.' });
      return;
    }

    doUpdatePostoAdm(e);
    console.log(formField);
    setAlert({ show: false, message: '' });
  };

  useEffect(() => {
    if (showEditDialog === false) {
      resetForm();
    }
  }, [showEditDialog]);

  useEffect(() => {
    if (selectedPostoAdms) {
      doFetchData(selectedPostoAdms);
    }
  }, [selectedPostoAdms]);

  useEffect(() => {
    if (selectedPostoAdms) {
      setFormField({
        ...formField,
        updated_by: parsedUser?.username,
        updated_at: formattedTime
      });
    }
  }, [formattedTime]);

  useEffect(() => {
    doFetchMunicipios([{ id: 'name', desc: false }]);
  }, []);

  // console.log(selectedPostoAdms);

  return (
    <Dialog open={showEditDialog} onOpenChange={(open) => handleEditDialog(open, null)}>
      <DialogContent className="container-fixed max-w-[768px] flex flex-col p-5 overflow-hidden">
        <DialogHeader>
          <DialogTitle>Postu Administrativo - Update</DialogTitle>
          <DialogDescription></DialogDescription>
        </DialogHeader>
        <DialogBody>
          <div className="flex flex-col">
            {alert.show && (
              <Alert variant="danger">
                <h3>{alert.message}</h3>
              </Alert>
            )}

            <form onSubmit={handleUpdate}>
              <div className="card-body grid gap-5">
                <div className="w-full">
                  <div className="flex items-baseline flex-wrap lg:flex-nowrap gap-2.5">
                    <label className="form-label flex items-center gap-1 max-w-56">
                      Postu Administrativo Name<span className="text-red-500">*</span>
                    </label>
                    <Input
                      className="input"
                      type="text"
                      value={formField.name}
                      onChange={(e) => setFormField({ ...formField, name: e.target.value })}
                    />
                  </div>
                </div>

                <div className="w-full">
                  <div className="flex items-baseline flex-wrap lg:flex-nowrap gap-2.5">
                    <label className="form-label flex items-center gap-1 max-w-56">
                      Municipio Name<span className="text-red-500">*</span>
                    </label>
                    <Popover open={open} onOpenChange={setOpen}>
                      <PopoverTrigger asChild>
                        <button type="button" className="input col-span-5 text-left">
                          {municipios.find((municipio) => municipio.id === formField.municipio_id)
                            ?.name || 'Select Municipio'}
                        </button>
                      </PopoverTrigger>
                      <PopoverContent className="w-[400px] p-0">
                        <Command>
                          <CommandInput placeholder="Search Municipio..." />
                          <CommandList>
                            <CommandEmpty>No Municipio found.</CommandEmpty>
                            <CommandGroup>
                              {municipios.map((municipio) => (
                                <CommandItem
                                  key={municipio.id}
                                  value={municipio.name}
                                  onSelect={() => {
                                    setFormField({
                                      ...formField,
                                      municipio_id: municipio.id
                                    });
                                    setOpen(false);
                                  }}
                                >
                                  {municipio.name}
                                </CommandItem>
                              ))}
                            </CommandGroup>
                          </CommandList>
                        </Command>
                      </PopoverContent>
                    </Popover>
                  </div>
                </div>

                <div className="flex justify-end gap-5">
                  <Button type="button" variant="outline" onClick={resetForm}>
                    Reset
                  </Button>
                  <Button className="btn btn-primary">Save Changes</Button>
                </div>
              </div>
            </form>
          </div>
        </DialogBody>
      </DialogContent>
    </Dialog>
  );
};

export default EditDialog;
